var Exp00200_lancamentoExpedicaoPedido_Controller = function(General, templateManager, ScreenService, Exp00200_lancamentoExpedicaoPedido_Service, ZHPromise, ZhFilterPreferences, MessageService) {


    this.filterOnEnter = function(widget){
        var promises = [];
        promises.push(ZhFilterPreferences.setOriginalFilter(widget.id));
        promises.push(ZhFilterPreferences.openFilterWidget(widget));
        ZHPromise.all(promises).then(function(rowSetFilter){
            this.setFilialLogadaFilter(widget);
            this.filterAdjustment();
        }.bind(this)); 
    };

    this.setFilialLogadaFilter = function (widget){
        Exp00200_lancamentoExpedicaoPedido_Service.getFilialLogada().then(function(filialLogada) {
            if (filialLogada[0]) {
                var widget = templateManager.container.getWidget('expedicaoPedido');
                templateManager.container.getActiveWidget().currentRow.CDFILIAL = filialLogada[0].CDFILIAL;
                templateManager.container.getActiveWidget().currentRow.NMFILIAL = filialLogada[0].NMFILIAL;
                
                this.setSerieFilter(widget);
                Exp00200_lancamentoExpedicaoPedido_Service.retornaEmpresa(filialLogada[0].CDEMPRESA).then(function(empresa) {
                    
                    templateManager.container.getActiveWidget().currentRow.CDEMPRESA = empresa[0].CDEMPRESA;
                    templateManager.container.getActiveWidget().currentRow.NMEMPRESA = empresa[0].NMEMPRESA;
                }.bind(this));
            } else {
                ScreenService.showMessage('Erro ao buscar Filial Logada, escolha manualmente.');
            }
        }.bind(this));
    };
    
    this.filterAdjustment = function (){
        Exp00200_lancamentoExpedicaoPedido_Service.getFilialLogada().then(function(filialLogada) {
            var cdfilial = filialLogada[0].CDFILIAL;
            var widget = templateManager.container.getWidget('expedicaoPedido');
            var widgetFiltro = templateManager.container.getActiveWidget();
            if (widgetFiltro && widgetFiltro.currentRow.CDFILIAL && filialLogada[0].CDFILIAL !== widgetFiltro.currentRow.CDFILIAL) {
                cdfilial = widgetFiltro.currentRow.CDFILIAL;
            }
            var filter = [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": cdfilial
                }
            ];
            widgetFiltro.currentRow.CDSERIE = '';
            widgetFiltro.currentRow.DSSERIE = '';
            this.setSerieFilter2(filter);
            General.callRestEngine('ped#/crud/parampedido', "FilterData", filter).then(function(callback){
                var params = callback.dataset.parampedido;
                // widget.transportadora = params[0].NRINSJURTRAN;
                if (params[0] && params[0].IDOBRTPOPPED == 'N'){
                    widget.getField('NMTIPOOPER').requiredParam = true;
                    widgetFiltro.getField('NMTIPOOPER').validations = {
                        required: true
                    };
                    widgetFiltro.getField('NMTIPOOPER').reload();
                } else if (params[0]){
                    widget.getField('NMTIPOOPER').requiredParam = false;
                    delete widgetFiltro.getField('NMTIPOOPER').validations;
                } else {
                    ScreenService.showMessage('Não foi encontrada nenhuma parametrização para a Filial escolhida.');
                }
            }.bind(this)).catch(function(callback){
                ScreenService.showMessage(callback.dataset.error);
            });
        }.bind(this)).catch(function(callback){
            ScreenService.showMessage(callback.dataset.error);
        }.bind(this));
    };
    
    this.setSerieFilter2 = function(filter){
        General.callRestEngine('ped#/crud/filial', "FilterData", filter).then(function(callback){
            if (callback.dataset.filial && callback.dataset.filial.length > 0) {
                var filialLogada = callback.dataset.filial;
                var widgetFiltro = templateManager.container.getActiveWidget();
                var widget = templateManager.container.getWidget('expedicaoPedido');
                
                var filtroFilial = [
                    {
                        "name": "CDFILIAL",
                        "operator": "=",
                        "value": filialLogada[0].CDFILIAL
                    }
                ];
                
                var filtroSerie = [
                    {
                        "name": "CDEMPRESA",
                        "operator": "=",
                        "value": filialLogada[0].CDEMPRESA
                    },
                    {
                        "name": "CDINSCESTA",
                        "operator": "=",
                        "value": filialLogada[0].CDINSCESTA
                    },
                    {
                        "name": "CDINSCMUNI",
                        "operator": "=",
                        "value": filialLogada[0].CDINSCMUNI
                    }
                ];

                widget.getField('DSSERIE').dataSourceFilter = filtroSerie;
                widgetFiltro.getField('DSSERIE').dataSourceFilter = filtroSerie;

                widget.getField('NRPEDIDO').dataSourceFilter = filtroFilial;
                widgetFiltro.getField('NRPEDIDO').dataSourceFilter = filtroFilial;

                widget.getField('NRPEDIDOINI').dataSourceFilter = filtroFilial;
                widgetFiltro.getField('NRPEDIDOINI').dataSourceFilter = filtroFilial;

                widget.getField('NRPEDIDOFIN').dataSourceFilter = filtroFilial;
                widgetFiltro.getField('NRPEDIDOFIN').dataSourceFilter = filtroFilial;

            }
        }.bind(this));
    };
    
    this.getCurrentField = function(widgetName, fieldName) {
        return General.getFieldValue(fieldName,widgetName);
    };

    this.setDataSourceFilterApply = function(args){
        if(templateManager.container.getActiveWidget().isValid()){
            var rowPopup = templateManager.container.getActiveWidget().currentRow;
            var dataSourceFilter = [
                /*{
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": rowPopup.CDFILIAL
                },*/
                {
                    "name": "PRIORIDADE",
                    "operator": "=",
                    "value": "321"
                },
                {
                    "name": "IDORIGDESTOP",
                    "operator": "=",
                    "value": "1"
                }
            ];
            if (rowPopup.TIPOFILTRO == 'L') {
                var listaPED = '_'+rowPopup.NRPEDIDO.join('_')+'_';
               // var lista = listaPED.replace(/\,/g, '_');
                //var newListaPED = '_'+lista+'_';

                dataSourceFilter.push(
                    {
                        "name": "LNRPEDIDO",
                        "operator": "=",
                        "value": listaPED
                    },
                    {
                        "name": "NRPEDIDOINI",
                        "operator": "=",
                        "value": null
                    },
                    {
                        "name": "NRPEDIDOFIN",
                        "operator": "=",
                        "value": null
                    },
                    {
                        "name": "TNRPEDIDO",
                        "operator": "=",
                        "value": null
                    }
                );
            } else if (rowPopup.TIPOFILTRO == 'I') {
                dataSourceFilter.push(
                    {
                        "name": "NRPEDIDOINI",
                        "operator": "=",
                        "value": rowPopup.NRPEDIDOINI
                    },
                    {
                        "name": "NRPEDIDOFIN",
                        "operator": "=",
                        "value": rowPopup.NRPEDIDOFIN
                    },
                    {
                        "name": "TNRPEDIDO",
                        "operator": "=",
                        "value": null
                    }
                );
            } else if (rowPopup.TIPOFILTRO == 'T' || !rowPopup.TIPOFILTRO) {
                dataSourceFilter.push(
                    {
                        "name": "TNRPEDIDO",
                        "operator": "=",
                        "value": "T"
                    }
                );
            }

            if (rowPopup.CDCLIENTE && rowPopup.CDCLIENTE.length != 0) {
                var listaCLIENTE = '_'+rowPopup.CDCLIENTE.join('_')+'_';
                dataSourceFilter.push(
                    {
                        "name": "CDCLIENTE",
                        "operator": "=",
                        "value": listaCLIENTE
                    },
                    {
                        "name": "TCDCLIENTE",
                        "operator": "=",
                        "value": null
                    }
                );
            } else {
                dataSourceFilter.push(
                    {
                        "name": "TCDCLIENTE",
                        "operator": "=",
                        "value": "T"
                    }
                );
            }

            if (rowPopup.CDVENDEDOR && rowPopup.CDVENDEDOR.length != 0) {
                var listaVENDEDOR = '_'+rowPopup.CDVENDEDOR.join('_')+'_';
                dataSourceFilter.push(
                    {
                        "name": "CDVENDEDOR",
                        "operator": "=",
                        "value": listaVENDEDOR
                    },
                    {
                        "name": "TCDVENDEDOR",
                        "operator": "=",
                        "value": null
                    }
                );
            } else {
                dataSourceFilter.push(
                    {
                        "name": "TCDVENDEDOR",
                        "operator": "=",
                        "value": "T"
                    }
                );
            }

            if (rowPopup.DTPEDIDO && rowPopup.DTPEDIDO.start && rowPopup.DTPEDIDO.end) {
                dataSourceFilter.push(
                    {
                        "name": "DTPEDIDOINI",
                        "operator": "=",
                        "value": rowPopup.DTPEDIDO.start
                    },
                    {
                        "name": "DTPEDIDOFIN",
                        "operator": "=",
                        "value": rowPopup.DTPEDIDO.end
                    },
                    {
                        "name": "TDTPEDIDO",
                        "operator": "=",
                        "value": null
                    }
                );
            } else {
                dataSourceFilter.push(
                    {
                        "name": "TDTPEDIDO",
                        "operator": "=",
                        "value": "T"
                    }
                );
            }
            
            if (rowPopup.CDTIPOOPER){
                dataSourceFilter.push(
                    {
                        "name": "CDTIPOOPER",
                        "operator": "=",
                        "value": rowPopup.CDTIPOOPER
                    }
                );
            } else {
                dataSourceFilter.push(
                    {
                        "name": "TCDTIPOOPER",
                        "operator": "=",
                        "value": "T"
                    }
                );
            }

            if (rowPopup.DTENTPED && rowPopup.DTENTPED.start && rowPopup.DTENTPED.end) {
                dataSourceFilter.push(
                    {
                        "name": "DTENTPEDINI",
                        "operator": "=",
                        "value": rowPopup.DTENTPED.start
                    },
                    {
                        "name": "DTENTPEDFIN",
                        "operator": "=",
                        "value": rowPopup.DTENTPED.end
                    },
                    {
                        "name": "TDTENTPED",
                        "operator": "=",
                        "value": null
                    }
                );
            } else {
                dataSourceFilter.push(
                    {
                        "name": "TDTENTPED",
                        "operator": "=",
                        "value": "T"
                    }
                );
            }
            
            args.owner.dataSourceFilter = args.owner.dataSourceFilter.concat(dataSourceFilter);

            for (var i = args.owner.dataSourceFilter.length-1; i >= 0; i--) {
                if (args.owner.dataSourceFilter[i].name == 'CDSERIE') {
                    args.owner.CDSERIE = args.owner.dataSourceFilter[i].value;
                    args.owner.dataSourceFilter.splice(i,1);
                }
            }
            for (i = args.owner.dataSourceFilter.length-1; i >= 0; i--) {
                if (args.owner.dataSourceFilter[i].name == 'CDEMPRESA') {
                    args.owner.CDEMPRESA = args.owner.dataSourceFilter[i].value;
                    args.owner.dataSourceFilter.splice(i,1);
                }
            }
            for (i = args.owner.dataSourceFilter.length-1; i >= 0; i--) {
                if (args.owner.dataSourceFilter[i].name == 'TIPOFILTRO') {
                    args.owner.CDEMPRESA = args.owner.dataSourceFilter[i].value;
                    args.owner.dataSourceFilter.splice(i,1);
                }
            }
            args.owner.container.getWidget('expedicaoPedido').reload();
        }
    };


    /*this.getCurrentFieldFilter = function(widgetName, fieldName) {
        var filterPopup = templateManager.container.getWidget(widgetName).__filterPopup;
        return General.getFieldValue(filterPopup.name, fieldName);
    };*/
    
    this.setSerieFilter = function(widget){
        var filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": widget.currentRow.CDFILIAL
            }
        ];
        General.callRestEngine('ped#/crud/filial', "FilterData", filter).then(function(callback){
            if (callback.dataset.filial && callback.dataset.filial.length > 0) {
                var widget = templateManager.container.getWidget('expedicaoPedido');
                var widgetFiltro = templateManager.container.getActiveWidget();
                var filialLogada = callback.dataset.filial;

                var filtroFilial = [
                    {
                        "name": "CDFILIAL",
                        "operator": "=",
                        "value": filialLogada[0].CDFILIAL
                    }
                ];

                var filtroSerie = [
                    {
                        "name": "CDEMPRESA",
                        "operator": "=",
                        "value": filialLogada[0].CDEMPRESA
                    },
                    {
                        "name": "CDINSCESTA",
                        "operator": "=",
                        "value": filialLogada[0].CDINSCESTA
                    },
                    {
                        "name": "CDINSCMUNI",
                        "operator": "=",
                        "value": filialLogada[0].CDINSCMUNI
                    }
                ];
                widget.getField('DSSERIE').dataSourceFilter       = filtroSerie;
                widgetFiltro.getField('DSSERIE').dataSourceFilter = filtroSerie;

                widget.getField('NRPEDIDO').dataSourceFilter = filtroFilial;
                widgetFiltro.getField('NRPEDIDO').dataSourceFilter = filtroFilial;

                widget.getField('NRPEDIDOINI').dataSourceFilter = filtroFilial;
                widgetFiltro.getField('NRPEDIDOINI').dataSourceFilter = filtroFilial;

                widget.getField('NRPEDIDOFIN').dataSourceFilter = filtroFilial;
                widgetFiltro.getField('NRPEDIDOFIN').dataSourceFilter = filtroFilial;

                widget.container.getActiveWidget().reload();
            }
        }.bind(this));
    };

    this.validaIntervaloPedido = function(args) {
        var tipoFiltro = args.owner.field.widget.currentRow.TIPOFILTRO;
        var NRPEDIDOINI = args.owner.field.widget.getField('NRPEDIDOINI');
        var NRPEDIDOFIN = args.owner.field.widget.getField('NRPEDIDOFIN');
        var NRPEDIDO = args.owner.field.widget.getField('NRPEDIDO');

        if (tipoFiltro == 'I') {
            this.setFieldRequired(NRPEDIDOINI);
            this.setFieldRequired(NRPEDIDOFIN);
            this.setFieldNotRequired(NRPEDIDO);
        } else if (tipoFiltro == 'L') {
            this.setFieldNotRequired(NRPEDIDOINI);
            this.setFieldNotRequired(NRPEDIDOFIN);
            this.setFieldRequired(NRPEDIDO);
        } else {
            this.setFieldNotRequired(NRPEDIDOINI);
            this.setFieldNotRequired(NRPEDIDOFIN);
            NRPEDIDO.isVisible = true;
            NRPEDIDO.readOnly = true;
            delete NRPEDIDO.validations;
        }

        NRPEDIDOINI.value('');
        NRPEDIDOFIN.value('');
        NRPEDIDO.value('');
    };

    this.setFieldRequired = function(field){
        field.isVisible = true;
        field.validations = {
            "required": true
        };
        field.readOnly = false;
    };

    this.setFieldNotRequired = function(field){
        field.isVisible = false;
        delete field.validations;
        field.readOnly = true;
    };

    this.expedirPedido = function(args){
        Exp00200_lancamentoExpedicaoPedido_Service.expedir(args);
    };

    this.setValueCurrentCliente = function(field){
        field.widget.currentRow.CDCLIENTE = field.value();
    };

    this.setValueCurrentVendedor = function(field){
        field.widget.currentRow.CDVENDEDOR = field.value();
    };

    this.changeField = function(field, arraySonFields, firstSonField){
		for(var index in arraySonFields){
			var fieldSon = field.widget.getField(arraySonFields[index]);
			fieldSon.clearValue();
			fieldSon.readOnly = true;
		}
		field.widget.getField(firstSonField).readOnly = !field.value();
	};

	this.salvarWidget = function(widget){
	    widget.saveRow(widget);
	};

	this.getEstoqueData = function(widget){
        // $cdfilial, $nrpedido, $nritemped, $cdproduto, $cdalmoxarife, $cdlocalestoq
        Exp00200_lancamentoExpedicaoPedido_Service.getEstoqueData(widget.getParent().currentRow).then(function(callback){
            widget.dataSource.data = callback.dataset.data;
        });
	};

	this.selectRow = function(widget){
        widget.getAction('expedir').isVisible = true;
	};

	this.deselectRow = function(widget){
        if(widget.getCheckedRows().length == 0){
            widget.getAction('expedir').isVisible = false;
        }
	};

	this.verificaPedido = function(widget){
        var checkedRows = widget.getCheckedRows();
        for (var i = 0; i < checkedRows.length; i++ ) {
            if (!(widget.getField('NMTIPOOPER').requiredParam) && !(checkedRows[i].CDTIPOOPER)){
                //ScreenService.showMessage("Pedido "+checkedRows[i].NRPEDIDO+' - '+checkedRows[i].NMFANTCLIE+" não possui tipo de operação cadastrada.");
                
                var var_nao_possui_operacao = "NAO_POSSUI_OPERACAO";
                MessageService.showMessageByCode(var_nao_possui_operacao,{"NRPEDIDO":checkedRows[i].NRPEDIDO, "NMFANTCLIE": checkedRows[i].NMFANTCLIE});
                i = checkedRows.length;
                widget.unSelectAll();
            }
            // if (!(widget.transportadora) && checkedRows[i] && !(checkedRows[i].NRINSJURTRAN)){
            //     this.checkTransportadora(checkedRows[i],widget);

            //     ScreenService.showMessage("Pedido "+checkedRows[i].NRPEDIDO+' - '+checkedRows[i].NMFANTCLIE+" não possui transportadora cadastrada.");
            //     i = checkedRows.length;
            //     widget.unSelectAll();
            // }
        }
    };

    /*this.checkTransportadora = function(row,widget){
        var filterClient = [
            {
                "name": "CDCLIENTE",
                "operator": "=",
                "value": row.CDCLIENTE
            }
        ];
        var filterFilial = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": row.CDFILIAL
            }
        ];
        var promise = [];
        promise.push(General.callRestEngine('ped#/crud/parexpedicao', "FilterData", filterFilial));
        ZHPromise.all(promise).then(function(callback){
            if (!callback[0].dataset.parexpedicao[0].NRINSJURTRAN) {
                ScreenService.showMessage("Pedido "+row.NRPEDIDO+' - '+row.NMFANTCLIE+" não possui transportadora cadastrada.");
            }
        });
    };*/

    this.qtdeControl = function(widget){
        var qtItem  = 0;
        var qtTotal = 0;
        for (var i = 0; i < widget.dataSource.data.length; i++) {
            qtItem = widget.dataSource.data[i].QTRESPRODPED_inline;
            if (qtItem) {
                if (typeof(qtItem) == 'string') {
                    qtItem = parseFloat(qtItem.replace(',', '.'));
                }
                qtTotal += qtItem;
            }
        }
        if (widget.currentRow.QTRESPRODPED_inline > widget.getParent().currentRow.QTITEMPED || qtTotal > widget.getParent().currentRow.QTITEMPED){
            ScreenService.showMessage('Quantidade escolhida maior que a quantidade do item no pedido.');
            widget.currentRow.QTRESPRODPED_inline = 0;
            widget.currentRow.QTRESPRODPED = 0;
            return false;
        } else if (widget.currentRow.QTRESPRODPED_inline > widget.currentRow.QTDISPONIVEL){
            ScreenService.showMessage('Quantidade escolhida maior que a disponível para este lote.');
            widget.currentRow.QTRESPRODPED_inline = 0;
            widget.currentRow.QTRESPRODPED = 0;
            return false;
        } else if (qtTotal == widget.getParent().currentRow.QTITEMPED){
            widget.currentRow.QTRESPRODPED = widget.currentRow.QTRESPRODPED_inline;
            return true;
        } else {
            ScreenService.showMessage('Quantidade escolhida diferente a quantidade do item no pedido.');
            return false;
        }
    };

    this.save = function(widget){
        var qtValida = this.qtdeControl(widget);
        if (qtValida) {
            Exp00200_lancamentoExpedicaoPedido_Service.setData('ped_expedicao#/lotes_expedicao', widget.dataSource.data).then(function(success){
                ScreenService.showMessage('Salvo com sucesso.');
                widget.view();
                widget.activate();
            });
        } else {
            for (var i = 0; i > widget.dataSource.data.length; i++) {
                widget.dataSource.data[i].QTRESPRODPED_inline = 0;
                widget.dataSource.data[i].QTRESPRODPED = 0;
            }
        }
    };

    this.getLocalData = function(widget){
        for (var i = 0; i < widget.dataSource.data.length; i++) {
            widget.dataSource.data[i].NRPEDIDO = widget.getParent().currentRow.NRPEDIDO;
            widget.dataSource.data[i].NRITEMPED = widget.getParent().currentRow.NRITEMPED;
        }
        var filter = [
            {
                "name": "NRPEDIDO",
                "operator": "=",
                "value": widget.getParent().currentRow.NRPEDIDO
            },
            {
                "name": "NRITEMPED",
                "operator": "=",
                "value": widget.getParent().currentRow.NRITEMPED
            }
        ];
        Exp00200_lancamentoExpedicaoPedido_Service.getData('ped_expedicao#/lotes_expedicao', filter).then(function(callback){
            var i;
            var e;
            if (callback.length > 0 ){
                for (i = 0; i < widget.dataSource.data.length; i++) {
                    for (e = 0; e < callback.length; e++) {
                        if (widget.dataSource.data[i].NRPEDIDO == callback[e].NRPEDIDO && widget.dataSource.data[i].NRITEMPED == callback[e].NRITEMPED &&
                          widget.dataSource.data[i].CDPRODUTO == callback[e].CDPRODUTO && widget.dataSource.data[i].NRLOTEESTQ == callback[e].NRLOTEESTQ &&
                          widget.dataSource.data[i].CDALMOXARIFE == callback[e].CDALMOXARIFE) {
                            widget.dataSource.data[i].QTRESPRODPED = callback[e].QTRESPRODPED;
                        }
                    }
                }
            } else {
                for (i = 0; i < widget.dataSource.data.length; i++) {
                    delete widget.dataSource.data[i].QTRESPRODPED;
                }
            }
        }.bind(this));
    };

};

Configuration(function(ContextRegister){
    ContextRegister.register('Exp00200_lancamentoExpedicaoPedido_Controller', Exp00200_lancamentoExpedicaoPedido_Controller);
});